-- Ŀ
--  Serial.E V1.01 (C) 1997 PJB Systems                    Serial RS232 lib 
-- 

global integer    PortIdx               PortIdx = 1
global integer    LocalEcho             LocalEcho = 0
global sequence   PortBase              PortBase = {#3F8,#2F8,#3E8,#2E8}

include Ports.E -- Come on RDS ! Even GWBASIC has I/O Access !!!

global function GetSerialByte(integer p)
  integer addr, lsr, byt
  byt = -1
  if (p > 0) and (p < 5) then
    addr = PortBase[p]
    lsr = and_bits(Input(addr + 5),1)
    if lsr > 0 then
      byt = Input(addr)
    end if
  end if
  return byt
end function

global procedure SendSerialByte(integer p,integer b)
  integer addr, lsr, ecd
  
  if (p > 0) and (p < 5) then
    if (b >= 0) and (b < 256) then
      addr = PortBase[p]
      ecd = 1000
      lsr = 0
      while (lsr = 0) and (ecd > 0) do
	lsr = and_bits(Input(addr + 5),64)
	ecd = ecd - 1
      end while
      Output(b,addr)
    end if
  end if
end procedure


global function GetPortBPDS(integer port)
  integer addr,dlab,baud, dvsr,tmp1,tmp2,parity,data,stop
  
  addr = PortBase[port]
  
  dlab = Input(addr + 3)
  tmp1 = dlab
  
  dlab = or_bits(dlab,#80)
  Output(dlab,addr + 3)
  
  dvsr = Input(addr) + (Input(addr + 1) * 256)
  
  dlab = and_bits(dlab,#7F)
  Output(dlab,addr + 3)
  
  if dvsr > 0 then
    baud = floor(115200 / dvsr)
  else
    baud = 0
  end if
  
  tmp2 = and_bits(tmp1,#38)
  parity = tmp2
  if tmp2 = 8 then
    parity = -1
  elsif tmp2 = 24 then
    parity = 1
  end if
  
  if and_bits(tmp1,4) > 0 then
    stop = 2
  else
    stop = 1
  end if  
  
  data = and_bits(tmp1,3) + 5
  
  return {baud,parity,data,stop}
end function

global procedure SetPortBPDS
  (integer port,integer baud,integer parity,integer data, integer stop)
  integer ok,addr, dlab, dvsr, dl, dh, p, s
  
  ok = 1
  if (port < 1) or (port > 4) then ok= 0 end if
  if (baud < 75) or (baud > 115200) then ok = 0 end if
  if (data < 5) or (data > 8) then ok = 0 end if
  if (stop < 1) or (stop > 2) then ok = 0 end if
  
  if ok > 0 then
    dvsr = floor(115200 / baud)
    dl = and_bits(#FF,dvsr)
    dh = floor(dvsr / 256)
    
    addr = PortBase[port]
    
    p = 0
    if parity > 0 then
      p = 24
    elsif parity < 0 then
      p = 8
    end if
    
    s = 0
    if stop = 2 then
      s = 4
    end if
    
    dlab = #80 + p + s + (data - 5)
    Output(dlab,addr + 3)
      
    Output(dl,addr)
    Output(dh,addr + 1)
    
    dlab = and_bits(dlab,#7F)
    Output(dlab,addr + 3)
  end if
end procedure

